<?php
/* MakeHello Package Building Script */
echo 'Creating Package';
/* package variables */
define('PKG_NAME', 'Hello2');

define('PKG_NAME_LOWER', strtolower(PKG_NAME));
define('PKG_VERSION', '1.0.0');
define('PKG_RELEASE', 'beta1');
/* now load the package builder and create the package */
$modx->loadClass('transport.modPackageBuilder',"",false, true);
$builder = new modPackageBuilder($modx);
$builder->createPackage(PKG_NAME_LOWER, PKG_VERSION, PKG_RELEASE);
$builder->registerNamespace(PKG_NAME_LOWER, false,true,'{core_path}components/' . PKG_NAME_LOWER.'/');
/* create or get the object to be packaged */
$obj= $modx->newObject('modSnippet');
/* alternative method gets the object from the DB:
* $obj = $modx->getObject('modSnippet', array('name'=>'Hello2'));
* if the object is retrieved from the
* DB, the following three lines
* are not necessary
*/
$obj->set('name', 'Hello2');
$obj->set('description', 'Hello2 1.0 beta1 ‑ prints: Hello World.');
$obj->setContent("$modx->lexicon->load('hello2:default');\n
    return $modx->lexicon('hello');");
/* alternate method gets the content from a file:
* $obj->setContent(file_get_contents('path_to file'));
*/
/* create category */
$category= $modx->newObject('modCategory');
$category->set('id', 1);
$category->set('category', PKG_NAME);
/* add snippet (remember $obj is our snippet) */
$snippets = array();
$snippets[] = $obj;
$category->addMany($snippets);
/* If we had chunks or other elements, we'd add them
* separately:
* $category->addMany($chunks);
*/
$attributes = array(
xPDOTransport::UNIQUE_KEY => 'category',
xPDOTransport::PRESERVE_KEYS => false,
xPDOTransport::UPDATE_OBJECT => true,
xPDOTransport::RELATED_OBJECTS => true,
xPDOTransport::RELATED_OBJECT_ATTRIBUTES => array (
'Snippets' => array(
xPDOTransport::PRESERVE_KEYS => false,
xPDOTransport::UPDATE_OBJECT => true,
xPDOTransport::UNIQUE_KEY => 'name',
),
/* If we had some chunks or other elements to add
* They would go here in separate arrays
* 'Chunks' => array (
* xPDOTransport::PRESERVE_KEYS => false,
* xPDOTransport::UPDATE_OBJECT => true,
* xPDOTransport::UNIQUE_KEY => 'name',
* ),
*/
),
);
$vehicle = $builder->createVehicle($category, $attributes);
/* Any validators or resolvers would go here */
$builder->putVehicle($vehicle);

/* zip up the package (will go to /core/packages) */
$builder->pack();
echo '<br />Package complete.';
?>