<?php
/* Code for ShowList Snippet */
/* Get our three chunks */
$outerChunk = $modx->getChunk($outerTpl);
$rowChunk = $modx->getChunk($rowTpl);
$itemChunk = $modx->getChunk($itemTpl);
/* Make sure we have all of them */
if (empty($outerChunk)) {
    return "Didn't get " . $outerTpl;
}
if (empty($rowChunk)) {
    return "Didn't get " . $rowTpl;
}
if (empty($itemChunk)) {
    return "Didn't get " . $itemTpl;
}
/* Set default items in a row to 3 */
$itemsInRow = empty($itemsInRow) ? '3' : $itemsInRow;
/* Set default separator within rows */
$separator = empty($separator) ? ', ' : $separator;
/* Keep HTML code from being all on one line */
$crlf = "\n";
$output = "";
/* Set default sort type */
$sortType = empty($sortType) ? 'NONE' : $sortType;
/* Set default list delimiter to comma */
$delimiter = empty($delimiter) ? ',' : $delimiter;
/* Create array of list items */
$list = $modx->getChunk($listChunk);
$listArray = explode($delimiter, $list);
/* Sort the list if directed to */
switch ($sortType) {
    case 'RANDOM':
        shuffle($listArray);
        break;
    case 'ASC':
        sort($listArray);
        break;
    case 'DESC':
        rsort($listArray);
        break;
}
/* Create array for formatted rows */
$rowArray = array();
$count = 0; /* Items in current row */
$itemCount = count($listArray); /*total items */
$currentRow = ""; /* Contents of current row */
/* Walk though the list items and add them to the current row */
foreach ($listArray as $key => $value) {
$itemCount-- ; /* Decrement itemCount */
$count++; /* Increment count */
/* Remove extra white space */
$value = trim($value);
/* Add separator if we're not at end of row or end of list */
if ($count != $itemsInRow && $itemCount > 0) {
    $value .= $separator;
}
/* Plug value into our item tpl and add to current row */
$value = str_replace('[[+sl.item]]', $value, $itemChunk);
$currentRow .= $value;
/* If we're at the end of row or end of list, format the current row
* with our row Tpl and add it to the row array */
if ($count == $itemsInRow || $itemCount == 0) {
    $rowArray[] = str_replace('[[+sl.row]]', $currentRow, $rowChunk);
    $count = 0;
    $currentRow = "";
}
}
/* Collapse row array in to one string, separating rows with $crlf
then plug the string into the outer tpl and return the result */
$output = implode($crlf, $rowArray);
$output = str_replace('[[+sl.outer]]', $output, $outerChunk);
return $output;
?>