<?php
/* Code for ObjectDemo Snippet */
$output = '<h2>Object Demo Snippet Output</h2>';
/* ‑‑‑‑‑‑ Add lines here ‑‑‑‑‑‑ */

$output .= '<h3>Current Resource Info</h3>';
$resource =& $modx->resource;
$fields = $resource->toArray();
$output .= '<pre>' . print_r($fields, true) . '</pre>';

$resource = $modx->getObject('modResource',
array('pagetitle'=>'DocName'));  /* Change DocName to the name of an actual resource */
$output .= '<p>The ' . $resource->get('pagetitle') . ' resource has ';
$output .= $resource->hasChildren() . ' children.';
if ($resource->get('isfolder')) {
$output .= ' and it is a folder.';
} else {
$output .= ' and it is not a folder';
}
$output .= '</p>';

if ($resource->hasChildren()) {
$id = $resource->get('id');
$children = $modx->getChildIds($id);
$output = '<p>Children: ';
$output .= implode(',',$children) . '</p>';
}

$resourceArray = $modx->getParentIds($id);
$output .= '<p>Parents: ' . implode(', ', resourceArray) . '</p>';

$resource =& $modx->resource;
$parentObject = $resource->getOne('Parent');
if ($parentObject) {
    $parentTitle = $parentObject->get('pagetitle');
} else {
    $parentTitle = 'No Parent';
}
$output .= '<h4>My Parent</h4>';
$output .= '<p>Parent Title: ' . $parentTitle . '</p>';

$output .= '<h4>My Creator</h4>';
$creator = $resource->getOne('CreatedBy');
$username = $creator->get('username');
$output .= '<p>I was created by: ' . $username . '</p>';

$resource =& $modx->resource;
$children = $resource->getMany('Children');
$output .= '<h4>My Children</h4>';
foreach ($children as $child) {
    $childTitle = $child->get('pagetitle');
    $output .= '<p>Child Title: ' . $childTitle . '</p>';
}

$resource = $modx->getObject('modResource',
array('pagetitle'=>'DocName')); /* replace DocName with the name of an actual resource */
$ancestorIds = $modx->getParentIds($resource->get('id'));
$output .= '<h4>Ancestors</h4>';
foreach ($ancestorsIds as $resourceId) {
   $ancestor = $modx->getObject('modResource', $resourceId);
   $ancestorTitle = $ancestor->get('pagetitle');
   $output .= '<p>Ancestor Title: ' . $ancestorTitle . '</p>';
}
$output .= '<h2>Published Resources</h2>';
$c = $modx->newQuery('modResource');
$c->select(array('id','pagetitle'));
$c->where(array('published'=>'1',
'createdby'=>'1',));
$c->sortby('id', 'ASC');
$docs = $modx->getCollection('modResource', $c);
foreach ($docs as $doc) {
$output .= '<p>Title:' . $doc->get('pagetitle') .
' ID:' . $doc->get('id') .'</p>';
}

$output .= '<h2>Me and My Parent</h2>';
$id = $modx->resource->get('id');
$resource = $modx->getObjectGraph('modResource',
array('Parent' => array()),
$id);
$output .= '<p>Me: ' . $resource->get('pagetitle') . '</p>';
$output .= 'My Parent: ' . $resource->Parent->get('pagetitle') . '</p>';
/* ‑‑‑‑‑‑‑‑‑‑‑‑‑‑‑‑‑‑‑‑‑‑‑‑‑‑‑‑ */
return $output;
?>