<?php
/* Code for ObjectDemo Snippet */
$output = '<h2>Object Demo Snippet Output</h2>';
/* ‑‑‑‑‑‑ Add lines here ‑‑‑‑‑‑ */

$output .= '<h3>Current Resource Info</h3>';
$resource =& $modx->resource;
$fields = $resource->toArray();
$output .= '<pre>' . print_r($fields, true) . '</pre>';

$resource = $modx->getObject('modResource',
array('pagetitle'=>'DocName'));  /* Change DocName to the name of an actual resource */
$output .= '<p>The ' . $resource->get('pagetitle') . ' resource has ';
$output .= $resource->hasChildren() . ' children.';
if ($resource->get('isfolder')) {
$output .= ' and it is a folder.';
} else {
$output .= ' and it is not a folder';
}
$output .= '</p>';

if ($resource->hasChildren()) {
$id = $resource->get('id');
$children = $modx->getChildIds($id);
$output = '<p>Children: ';
$output .= implode(',',$children) . '</p>';
}

$resourceArray = $modx->getParentIds($id);
$output .= '<p>Parents: ' . implode(', ', resourceArray) . '</p>';

$resource =& $modx->resource;
$parentObject = $resource->getOne('Parent');
if ($parentObject) {
    $parentTitle = $parentObject->get('pagetitle');
} else {
    $parentTitle = 'No Parent';
}
$output .= '<h4>My Parent</h4>';
$output .= '<p>Parent Title: ' . $parentTitle . '</p>';

$output .= '<h4>My Creator</h4>';
$creator = $resource->getOne('CreatedBy');
$username = $creator->get('username');
$output .= '<p>I was created by: ' . $username . '</p>';

$resource =& $modx->resource;
$children = $resource->getMany('Children');
$output .= '<h4>My Children</h4>';
foreach ($children as $child) {
    $childTitle = $child->get('pagetitle');
    $output .= '<p>Child Title: ' . $childTitle . '</p>';
}

$resource = $modx->getObject('modResource',
array('pagetitle'=>'DocName')); /* replace DocName with the name of an actual resource */
$ancestorIds = $modx->getParentIds($resource->get('id'));
$output .= '<h4>Ancestors</h4>';
foreach ($ancestorsIds as $resourceId) {
   $ancestor = $modx->getObject('modResource', $resourceId);
   $ancestorTitle = $ancestor->get('pagetitle');
   $output .= '<p>Ancestor Title: ' . $ancestorTitle . '</p>';
}
$output .= '<h2>Published Resources</h2>';
$c = $modx->newQuery('modResource');
$c->select(array('id','pagetitle'));
$c->where(array('published'=>'1',
'createdby'=>'1',));
$c->sortby('id', 'ASC');
$docs = $modx->getCollection('modResource', $c);
foreach ($docs as $doc) {
$output .= '<p>Title:' . $doc->get('pagetitle') .
' ID:' . $doc->get('id') .'</p>';
}

$output .= '<h2>Me and My Parent</h2>';
$id = $modx->resource->get('id');
$resource = $modx->getObjectGraph('modResource',
array('Parent' => array()),
$id);
$output .= '<p>Me: ' . $resource->get('pagetitle') . '</p>';
$output .= 'My Parent: ' . $resource->Parent->get('pagetitle') . '</p>';

$output .= '<h2>Resources and their Children</h2>';
$criteria = array('published'=>'1');
$resources = $modx->getCollectionGraph('modResource',
array('Children' => array()),
$criteria);
foreach($resources as $resource) {
$output .= '<p>Resource: ' . $resource->get('pagetitle');
if ($resource->hasChildren($resource->get('id')) ) {
foreach ($resource->Children as $child) {
$output .= ' >> ' . $child->get('pagetitle');
}
} else {
$output .= ' >> No Children';
}
$output .= '</p>';
}

$output .= '<h3>Properties</h3>';
foreach($scriptProperties as $key=>$value) {
$output .= '<p>KEY: ' . $key . '=>' . ' VALUE: ' . $value . '</p>';
}

$propSet = array(
'listChunk' => 'ListData',
'itemTpl' => 'ItemTpl',
'rowTpl' => 'RowTpl',
'outerTpl' => 'OuterTpl',
);
$output .= '<h2>runSnippet</h2>';
$output .= $modx->runSnippet('ShowList', $propSet);

$output .= '<h2>Settings</h2>';
$output .= '<p>Site Start ID: ' . $modx->getOption('site_start') . '</p>';
$output .= '<p>Character Encoding: ' .
$modx->getOption('modx_charset') . '</p>';

$output .= '<h2>User info</h2>';
$output .= '<h3>Current User</h3>';
$username = $modx->user->get('username');
$output .= '<p>Username: ' . $username . '</p>';
if ($username != '(anonymous)') {
$profile = $modx->user->getOne('Profile');
$fullname = $profile->get('fullname');
$email = $profile->get('email');
$output .= '<p>User Full Name: '. $fullname . '</p>';
$output .= '<p>User email: '. $email . '</p>';
}

$output .= "<h3>current doc's related users.</h3>";
$creator = $modx->getObjectGraph('modUser',
array('Profile' => array()),
$modx->user->get('createdby'));
$creatorFields = array_merge($creator->toArray(),
$creator->Profile->toArray());
$modx->toPlaceholders($creatorFields, 'creator');
$editor = $modx->getObjectGraph('modUser',
array('Profile' => array()),
$modx->user->get('editedby'));
$editorFields = array_merge($editor->toArray(),
$editor->Profile->toArray());
$modx->toPlaceholders($editorFields, 'editor');
$publisher = $modx->getObjectGraph('modUser',
array('Profile' => array()),
$modx->user->get('publishedby'));
$publisherFields = array_merge($publisher->toArray(),
$publisher->Profile->toArray());
$modx->toPlaceholders($publisherFields, 'publisher');
$output .= $modx->GetChunk('RelatedUserTpl');

$output .= "<h3>YesNoDemo doc's related users.</h3>";
$resource = $modx->getObject('modResource',
array('pagetitle'=>'YesNoDemo'));
$creator = $resource->getOne('CreatedBy');
$output .= '<p>YesNoDemo was Created by: '.
$creator->get('username') . '</p>';

$user = $modx->getObjectGraph('modUser',
array('Profile' => array()),
array('username'=>'JaneDoe'));
$modx->toPlaceholders($user->toArray(),'user');
$modx->toPlaceholders($user->Profile->get('extended'),'extended');

$user = $modx->getObjectGraph('modUser',
array('Profile' => array()),
array('username'=>'JaneDoe'));
$extFields = $user->Profile->get('extended');
$extFields['sign'] = 'Virgo';
$user->Profile->set('extended',$extFields);
$user->save();

$users = $modx->getCollectionGraph('modUser',
array('Profile' => array()),
array('active'=>'1'));
foreach($users as $user) {
$extFields = $user->Profile->get('extended');
$extFields['new‑field'] = '(blank)';
$user->Profile->set('extended',$extFields);
$user->Profile->save();
}
return '<p>Fields Created</p>';

/* ‑‑‑‑‑‑‑‑‑‑‑‑‑‑‑‑‑‑‑‑‑‑‑‑‑‑‑‑ */
return $output;
?>